data Format =
      FString Format -- %s
    | FLit String Format -- a literal string
    | FEnd

%name Format f, f1, f2, f3

-- "name = %s"
exampleFormat : Format
exampleFormat = FLit "name = " (FString FEnd)

toFormat : String -> Format
toFormat s = loop (unpack s)
  where
    prepend : Char -> Format -> Format
    prepend c (FString y) = FLit (singleton c) (FString y)
    prepend c (FLit y f) = FLit (strCons c y) f
    prepend c FEnd = FLit (singleton c) FEnd
    loop : List Char -> Format
    loop [] = FEnd
    loop ('%' :: 's' :: xs) = FString (loop xs)
    loop ('%' :: '%' :: xs) = prepend '%' (loop xs)
    loop (c :: xs) = prepend c (loop xs)

PrintfType : Format -> Type
PrintfType (FString f) = String -> PrintfType f
PrintfType (FLit x f) = PrintfType f
PrintfType FEnd = String

printf' : (f: Format) -> String -> PrintfType f
printf' (FString f) acc = \s => printf' f (acc ++ s)
printf' (FLit x f) acc = printf' f (acc ++ x)
printf' FEnd acc = acc

printf : (s: String) -> PrintfType (toFormat s)
printf s = printf' (toFormat s) ""


