infixr 7 ::

data Vect : Nat -> Type -> Type where
  Nil : Vect Z a
  (::) : a -> Vect n a -> Vect (S n) a

%name Vect xs,ys,zs,ws

total head : Vect (S n) a -> a
head (x :: _) = x

total zip : Vect n a -> Vect n b -> Vect n (a, b)
zip (x :: xs) (y :: ys) = (x, y) :: zip xs ys
zip [] [] = []

total append : Vect n a -> Vect m a -> Vect (n + m) a
append [] ys = ys
append (x :: xs) ys = x :: append xs ys

total ltDec : LT (S k) (S n) -> LT k n
ltDec (LTESucc x) = x

total elemAt : (k : Nat) -> Vect n a -> LT k n -> a
elemAt Z (y :: xs) prf = y
elemAt (S k) (y :: xs) prf = elemAt k xs (ltDec prf)
